#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Initial variables for reference
#define WINDOWSIZE 200
#define DAX 0.03199	
#define DAY 0.03199
#define DIX 0.229
#define DIY 0.229
#define S 0.005
*/

#define WINDOWSIZE 200
#define DAX 0.03199
#define DAY 0.03199
#define DIX 0.209
#define DIY 0.229
#define S 0.005	
GLfloat BETA[WINDOWSIZE][WINDOWSIZE];
GLfloat cA[WINDOWSIZE][WINDOWSIZE];
GLfloat cI[WINDOWSIZE][WINDOWSIZE];
GLfloat oldCA[WINDOWSIZE][WINDOWSIZE];
GLfloat oldCI[WINDOWSIZE][WINDOWSIZE];
GLfloat displayMatrix[WINDOWSIZE][WINDOWSIZE][3];

int count=0;

void save()
{
	int i,j;
	for (i=0;i<WINDOWSIZE;i++){
		for (j=0;j<WINDOWSIZE;j++){
			oldCA[i][j]=cA[i][j];
			oldCI[i][j]=cI[i][j];
			displayMatrix[i][j][0]=cA[i][j]/6.0;
			displayMatrix[i][j][1]=cA[i][j]/6.0;
			displayMatrix[i][j][2]=cA[i][j]/6.0;
			
		}
	}
}

void changeImage()
{
	int i,j;
	GLfloat I, A, Ix, Ax, Iy, Ay;
	for (i=1;i<WINDOWSIZE-1;i++){
		for (j=0;j<WINDOWSIZE;j++){
			I=S*(16-oldCI[i][j]*oldCA[i][j]);
			A=S*(oldCI[i][j]*oldCA[i][j]-oldCA[i][j]-BETA[i][j]);

			Ix=DIX*(oldCI[i+1][j]+oldCI[i-1][j]-2*oldCI[i][j]);
			Iy=DIY*(oldCI[i][j-1]+oldCI[i][j+1]-2*oldCI[i][j]);
			
			Ax=DAX*(oldCA[i+1][j]+oldCA[i-1][j]-2*oldCA[i][j]);
			Ay=DAY*(oldCA[i][j-1]+oldCA[i][j+1]-2*oldCA[i][j]);
			cI[i][j]+=I+Ix+Iy;
			cA[i][j]+=A+Ax+Ay;
			
			if (cA[i][j]<0.0)
				cA[i][j]=0.0;
			
		}
	}
	
}
	
void myinit()
{

	int i,j;
	GLfloat color=0.0;
	glShadeModel(GL_FLAT);
	srand((unsigned)time(NULL));
	glClearColor(0.0,0.0,0.0,1.0); /* Black Background */
		
	for (i=0;i<WINDOWSIZE;i++)
	{		
		for (j=0;j<WINDOWSIZE;j++){
			color=4.0;//(4.0*rand()/(RAND_MAX+1.0)); //random no. between 0.0 and 1.0
			cA[i][j]=color;
			color=4.0;//(4.0*rand()/(RAND_MAX+1.0)); //random no. between 0.0 and 1.0
			cI[i][j]=color;
			color=(0.1*rand()/(RAND_MAX+1.0))+11.95; //random no. between 11.5 and 12.5
			BETA[i][j]=color;
		}
	
	}
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	save(); //save concentrations
}
   

static int timer = 0;

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glRasterPos2i(-1,-1);
	changeImage();
	save();
	glDrawPixels(WINDOWSIZE,WINDOWSIZE, GL_RGB,GL_FLOAT,displayMatrix);
	if (timer%100 == 0)
		printf("%d\n",timer);		
	glFlush();	
	glutSwapBuffers();
	glutPostRedisplay();
	timer++;
}

void idle(void) {
	display();
}
	
int main(int argc, char ** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(WINDOWSIZE,WINDOWSIZE);
	glutInitWindowPosition(0,0);
	glutCreateWindow("Testing Draw Pixel");
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	myinit();
	glutMainLoop();
}
